/*
 * Package:    comm
 * File:       AVRReader.java
 * Created on: 16.01.2005
 *
 */
package comm;

import gui.MainWindow;

import java.io.InputStream;

import javax.comm.CommPortIdentifier;
import javax.comm.SerialPort;
import javax.comm.SerialPortEvent;
import javax.comm.SerialPortEventListener;

/**
 * @author Ape
 */
public class AVRReader implements SerialPortEventListener {
	
	private MainWindow gui;
	
	SerialPort port;
	InputStream in;
	double[] values = new double[63];
	int valueIndex = 0, len;
	boolean start = false;
	
	public AVRReader(MainWindow gui, String p) {
		this.gui = gui;
		
		try {
			CommPortIdentifier portId = CommPortIdentifier.getPortIdentifier(p);
			port = (SerialPort)portId.open("SpecAnaTest", 500);
			port.notifyOnDataAvailable(true);
			port.addEventListener(this);
			port.setSerialPortParams(115200,
					SerialPort.DATABITS_8,
					SerialPort.STOPBITS_1,
					SerialPort.PARITY_NONE);
			in = port.getInputStream();
			System.out.println(p+" opened");
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void stop() {

		try {
			in.close();
			port.close();
		} catch(Exception e){}
	}
	
	/* (non-Javadoc)
	 * @see javax.comm.SerialPortEventListener#serialEvent(javax.comm.SerialPortEvent)
	 */
	public void serialEvent(SerialPortEvent e) {

		//System.out.println("event");
		
		try {
			while(in.available() > 0) {
				int b;
				byte buf[] = new byte[512];
		
				len = in.read(buf);
				for(int j=0; j<len; j++) {
					b = buf[j];
					if(b < 0) b += 256;
					
					if(b == 254) {
						start = true;
					} else if(start) {
						values[valueIndex++] = b;
		
						if(valueIndex == values.length) {
							gui.setValues(values);
							valueIndex = 0;
							start = false;
						}
					}
				}
			}
					
		} catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
